## ena-driver-2.16.0-linux.tar.gz

=== kernel/fbsd/ena/Makefile ===
#
# SPDX-License-Identifier: BSD-2-Clause
#
# Copyright (c) 2015-2024 Amazon.com, Inc. or its affiliates.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# # Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# # Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in
# the documentation and/or other materials provided with the
# distribution.
# # Neither the name of copyright holder nor the names of its
# contributors may be used to endorse or promote products derived
# from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


.include <bsd.own.mk>

.PATH:  ${.CURDIR}
.PATH:  ${.CURDIR}/ena-com
KMOD    = if_ena

# Shared source
SRCS    = device_if.h bus_if.h pci_if.h
SRCS	+= ena_com.c ena_eth_com.c
SRCS	+= ena.c ena_sysctl.c ena_datapath.c ena_netmap.c ena_rss.c

CFLAGS  += -DSMP -O2
CFLAGS  += -I${.CURDIR}/ena-com

KERNEL_VERSION := `sysctl -n kern.osreldate`
CFLAGS  += -D__FreeBSD_version=$(KERNEL_VERSION)

.if defined(DEBUG)
# Enable debug messages and sysctls
CFLAGS  += -DENA_DEBUG
# Enable logging on Tx/Rx data path.
# When disabled, ena_log_io calls remain compiled out for performance purposes.
CFLAGS += -DENA_LOG_IO_ENABLE
.endif

# Try to determine if the driver should be built with the DEV_NETMAP option.
# It will be enabled if:
# - user doesn't define DEV_NETMAP variable and the current kernel has been
#   built with the 'device netmap'
# - user defines DEV_NETMAP variable and it's value is not 0.
.if !make(clean) && ((!defined(DEV_NETMAP) && \
    ${:!sysctl dev.netmap > /dev/null 2>&1; echo \$?!} == 0) || \
    (defined(DEV_NETMAP) && ${DEV_NETMAP} != 0))
.info Enabling DEV_NETMAP for the driver.
CFLAGS += -DDEV_NETMAP
.endif

# Try to determine if the driver should be built with the RSS option.
# The requirements are similar as for the DEV_NETMAP option, except that the
# script checks for the RSS option and variable instead.
.if !make(clean) && ((!defined(RSS) && \
    ${:!sysctl net.inet.rss > /dev/null 2>&1; echo \$?!} == 0) || \
    (defined(RSS) && ${RSS} != 0))
.info Enabling kernel RSS for the driver.
CFLAGS += -DRSS
.endif

# Try to determine if the driver should be built with the extra debugging
# facilities which also must be provided by the kernel.
# As those options may affect driver's performance by adding extra sanity
# checks, they must be explicitely enabled by passing the DEBUG variable to
# the make command.
# Please note that enabling those options in the kernel will affect the driver's
# performance anyway.
.if !make(clean) && defined(DEBUG) && ((!defined(INVARIANT_SUPPORT) && \
    ${:!sysctl kern.features.invariant_support > /dev/null 2>&1; echo \$?!} == 0) || \
    (defined(INVARIANT_SUPPORT) && ${INVARIANT_SUPPORT} != 0))
.info Enabling INVARIANT_SUPPORT debug flag.
CFLAGS += -DINVARIANT_SUPPORT
.endif
.if !make(clean) && defined(DEBUG) && ((!defined(INVARIANTS) && \
    ${:!sysctl kern.features.invariants > /dev/null 2>&1; echo \$?!} == 0) || \
    (defined(INVARIANTS) && ${INVARIANTS} != 0))
.info Enabling INVARIANTS debug flag.
CFLAGS += -DINVARIANTS
.endif
.if !make(clean) && defined(DEBUG) && ((!defined(WITNESS) && \
    ${:!sysctl kern.features.witness > /dev/null 2>&1; echo \$?!} == 0) || \
    (defined(WITNESS) && ${WITNESS} != 0))
.info Enabling WITNESS debug flag.
CFLAGS += -DWITNESS
.endif
.if !make(clean) && defined(DEBUG) && ((!defined(WITNESS_SKIPSPIN) && \
    ${:!sysctl debug.witness.skipspin 2> /dev/null | grep '1' > /dev/null; echo \$?!} == 0) || \
    (defined(WITNESS_SKIPSPIN) && ${WITNESS_SKIPSPIN} != 0))
.info Enabling WITNESS_SKIPSPIN debug flag.
CFLAGS += -DWITNESS_SKIPSPIN
.endif

clean:
	rm -f opt_global.h opt_bdg.h device_if.h bus_if.h pci_if.h setdef* *_StripErr
	rm -f *.o *.kld *.ko .*.o
	rm -f @ export_syms machine x86

.include <bsd.kmod.mk>

=== kernel/linux/efa/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0 OR BSD-2-Clause
# Copyright 2021-2025 Amazon.com, Inc. or its affiliates. All rights reserved.

cmake_minimum_required(VERSION 3.10)
project(efa C)

set(KERNEL_VER "" CACHE STRING "Kernel version to build for")
if(NOT KERNEL_VER)
  execute_process(COMMAND uname -r OUTPUT_VARIABLE uname_r
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(KERNEL_DIR "/lib/modules/${uname_r}/build")
else()
  set(KERNEL_DIR "/lib/modules/${KERNEL_VER}/build")
endif()

unset(KERNEL_MAKEFILE CACHE)
find_file(KERNEL_MAKEFILE Makefile PATHS ${KERNEL_DIR} NO_DEFAULT_PATH)
if(NOT KERNEL_MAKEFILE)
  message(FATAL_ERROR "No kernel Makefile")
endif()
message("-- Kernel directory - ${KERNEL_DIR}")

set(GCOV_PROFILE OFF CACHE BOOL "Enable GCOV profiling")
set(ENABLE_P2P ON CACHE BOOL "Enable Peer-to-peer memory")
set(ENABLE_KVERBS ON CACHE BOOL "Enable kernel verbs support")

add_subdirectory(src)

=== kernel/linux/efa_nv_peermem/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0 OR BSD-2-Clause
# Copyright 2023-2025 Amazon.com, Inc. or its affiliates. All rights reserved.

cmake_minimum_required(VERSION 3.10)
project(efa_nv_peermem C)

set(KERNEL_VER "" CACHE STRING "Kernel version to build for")
if(NOT KERNEL_VER)
  execute_process(COMMAND uname -r OUTPUT_VARIABLE uname_r
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(KERNEL_DIR "/lib/modules/${uname_r}/build")
else()
  set(KERNEL_DIR "/lib/modules/${KERNEL_VER}/build")
endif()

unset(KERNEL_MAKEFILE CACHE)
find_file(KERNEL_MAKEFILE Makefile PATHS ${KERNEL_DIR} NO_DEFAULT_PATH)
if(NOT KERNEL_MAKEFILE)
  message(FATAL_ERROR "No kernel Makefile")
endif()
message("-- Kernel directory - ${KERNEL_DIR}")

set(NVIDIA_DIR "" CACHE PATH "Path to NVIDIA directory")
if(NVIDIA_DIR)
  unset(NVIDIA_MODULE_SYMVERS CACHE)
  file(GLOB_RECURSE NVIDIA_MODULE_SYMVERS "${NVIDIA_DIR}/Module.symvers")
  if(NOT NVIDIA_MODULE_SYMVERS)
    message(FATAL_ERROR "No NVIDIA Module.symvers found under ${NVIDIA_DIR}")
  endif()
  list(GET NVIDIA_MODULE_SYMVERS 0 NVIDIA_MODULE_SYMVERS)
  message("-- NVIDIA directory - ${NVIDIA_DIR}")
  message("-- NVIDIA module symbols - ${NVIDIA_MODULE_SYMVERS}")
endif()

set(GCOV_PROFILE OFF CACHE BOOL "Enable GCOV profiling")

add_subdirectory(src)

=== kernel/linux/ena/Makefile ===
ENA_COM_PATH=../common/ena_com/

this_mkfile_path := $(dir $(realpath $(lastword $(MAKEFILE_LIST))))

DRIVER_NAME := ena

$(DRIVER_NAME)-srcs := ena_netdev.c \
		ena_ethtool.c \
		ena_lpc.c	\
		ena_phc.c \
		ena_xdp.c \
		dim.c \
		net_dim.c \
		ena_devlink.c \
		$(ENA_COM_PATH)/ena_com.c \
		$(ENA_COM_PATH)/ena_eth_com.c

$(DRIVER_NAME)-sysfs-srcs := ena_sysfs.c
$(DRIVER_NAME)-debug_fs-srcs := ena_debugfs.c

HEADER_FILES := $(shell find $(this_mkfile_path) $(this_mkfile_path)/$(ENA_COM_PATH) -type f -name '*.h')

obj-m += $(DRIVER_NAME).o
$(DRIVER_NAME)-objs := $(patsubst %.c,%.o,$($(DRIVER_NAME)-srcs))
$(DRIVER_NAME)-$(CONFIG_SYSFS) += $(patsubst %.c,%.o,$($(DRIVER_NAME)-sysfs-srcs))
$(DRIVER_NAME)-$(CONFIG_DEBUG_FS) += $(patsubst %.c,%.o,$($(DRIVER_NAME)-debug_fs-srcs))

ccflags-y := -I$(src)
ccflags-y += -I$(src)/$(ENA_COM_PATH)/


BUILD_KERNEL ?= $(shell uname -r)
# allow user to override the build directory
KERNEL_BUILD_DIR ?= /lib/modules/$(BUILD_KERNEL)/build

ccflags-y += -Wfatal-errors

GENERATED_EXISTS := $(shell if [ -d include/generated ]; then echo True; fi)

ifneq ($(strip $(GENERATED_EXISTS)),)
  IS_UEK=$(shell grep uek include/generated/utsrelease.h)

  ifneq ($(strip $(IS_UEK)),)
    IS_3_8_13=$(shell grep -F 3.8.13 include/generated/utsrelease.h)

    ifneq ($(strip $(IS_3_8_13)),)
      ccflags-y += -DUEK3_RELEASE
    endif
  endif
endif

get_kernel_subversions = $(shell \
  subversions_array_tmp=(`uname -r | sed 's/[^0-9]\+/ /g ; s/\s$$//'`) && \
  for (( i = 0; i < 6; i++ )); do \
    subversions_array[$$i]="ENA_KERNEL_SUBVERSION_$$(($$i+1))=$${subversions_array_tmp[$$i]:-0}"; \
  done && \
  echo $${subversions_array[*]})

ifneq ("$(wildcard /etc/os-release)","")
  IS_DEBIAN=$(shell grep Debian /etc/os-release)

  ifneq ($(strip $(IS_DEBIAN)),)
    DEBIAN_VERSION_LINE=$(shell grep VERSION_ID /etc/os-release)
    REMOVE_QUOTES = $(subst $\",,$(DEBIAN_VERSION_LINE))
    REMOVE_EQUAL_SIGN = $(subst $\=,,$(REMOVE_QUOTES))
    DEBIAN_VERSION = $(subst VERSION_ID,,$(REMOVE_EQUAL_SIGN))
    ccflags-y += -DDEBIAN_VERSION=$(DEBIAN_VERSION)
  endif

  IS_SUSE=$(shell grep SUSE /etc/os-release)
  IS_UEK=$(shell uname -r | grep uek)
  IS_FEDORA=$(shell grep Fedora /etc/os-release)
  ifneq ($(strip $(IS_FEDORA)),)
    ccflags-y += -DFEDORA_RELEASE
  endif

  IS_KERNEL_SUBVERSIONS_NEEDED=$(IS_SUSE)$(IS_UEK)

  ifneq ($(strip $(IS_KERNEL_SUBVERSIONS_NEEDED)),)
    ifneq ($(strip $(IS_UEK)),)
      ccflags-y += -DIS_UEK
    endif

    ENA_KERNEL_SUBVERSIONS := $(call get_kernel_subversions)
    $(foreach subversion,$(ENA_KERNEL_SUBVERSIONS),$(eval ccflags-y += -D$(subversion)))
  endif

endif

ifdef UBUNTU_ABI
	ccflags-y += -DUTS_UBUNTU_RELEASE_ABI=$(UBUNTU_ABI)
endif

ifdef ENA_PHC_INCLUDE
	ccflags-y += -DENA_PHC_INCLUDE
endif

ifdef ENA_DEVLINK_INCLUDE
	ccflags-y += -DENA_DEVLINK_INCLUDE
endif

all: $(DRIVER_NAME).ko

$(DRIVER_NAME).ko: config.h $(HEADER_FILES) $($(DRIVER_NAME)-srcs) $($(DRIVER_NAME)-sysfs-srcs) $($(DRIVER_NAME)-debug_fs-srcs)
	$(MAKE) -C $(KERNEL_BUILD_DIR) M=$(CURDIR) modules

config.h:
	./configure.sh --kernel-dir $(KERNEL_BUILD_DIR) --verbose

clean:
	$(MAKE) -C $(KERNEL_BUILD_DIR) M=$(CURDIR) clean
	rm -f config.h
	rm -rf cc_test
	rm -f $(ENA_COM_PATH)/*.o $(ENA_COM_PATH)/.*.o.cmd

=== kernel/linux/rpm/Makefile ===
# Makefile for creating a source rpm of the Amazon ENA driver
#
# Author: Cristian Gafton <gafton@amazon.com>

NAME	= ena
VERSION	= 2.16.0

TOPDIR	:= $(shell git rev-parse --show-toplevel)

TAG	= $(NAME)_linux_$(VERSION)
TARBALL	= $(NAME)-$(VERSION).tar

RPMDEFS = --define '_topdir  %(pwd)' \
	  --define '_ntopdir %(pwd)' \
	  --define '_builddir  %{_ntopdir}/build' \
	  --define '_buildrootdir %{_builddir}' \
	  --define '_sourcedir %{_ntopdir}' \
	  --define '_specdir   %{_ntopdir}' \
	  --define '_rpmdir    %{_ntopdir}' \
	  --define '_srcrpmdir %{_ntopdir}'

all : srpm

tarball : $(TARBALL)
$(TARBALL) : always
	(cd $(TOPDIR) && \
		git archive --format=tar --prefix=$(NAME)-$(VERSION)/ $(TAG) \
		kernel/linux/{common,ena}) > $@

srpm : $(TARBALL) Makefile
	rpmbuild -bs $(RPMDEFS) $(wildcard *.spec)

rpm : $(TARBALL) Makefile
	rpmbuild -ba $(RPMDEFS) $(wildcard *.spec)

clean :
	rm -f $(TARBALL) *.src.rpm

always :

.PHONY : srpm clean always

=== kernel/linux/efa/config/Makefile ===
# SPDX-License-Identifier: GPL-2.0 OR BSD-2-Clause
# Copyright 2020 Amazon.com, Inc. or its affiliates. All rights reserved.

DRIVER_NAME = conftest
KBUILD_CPPFLAGS += -Werror -Wno-unused-variable -Wno-uninitialized -Wno-maybe-uninitialized

obj-m += $(DRIVER_NAME).o
$(DRIVER_NAME)-objs := main.o

KERNEL_DIR ?= /lib/modules/$(shell uname -r)/build

modules:
	$(MAKE) -C $(KERNEL_DIR) M=$(CURDIR) modules

=== kernel/linux/efa/rpm/Makefile ===
# Makefile for creating rpm of the Amazon EFA driver

NAME = efa
SPEC = $(NAME).spec
VERSION	= 2.17.3

TOPDIR  := $(shell git rev-parse --show-toplevel)
TAG	?= HEAD
TARBALL	= $(NAME)-$(VERSION).tar

RPMDEFS = --define '_topdir  %(pwd)' \
          --define '_ntopdir %(pwd)' \
          --define '_builddir  %{_ntopdir}/build' \
          --define '_buildrootdir %{_builddir}' \
          --define '_sourcedir %{_ntopdir}' \
          --define '_specdir   %{_ntopdir}' \
          --define '_rpmdir    %{_ntopdir}' \
          --define '_srcrpmdir %{_ntopdir}' \
	  --define "driver_version $(VERSION)"

all : rpm

tarball : $(TARBALL)
$(TARBALL) : always
	(cd $(TOPDIR) && \
	git archive --format=tar --prefix=$(NAME)-$(VERSION)/ $(TAG) \
	kernel/linux/efa/) > $@

srpm : $(TARBALL) Makefile
	rpmbuild -bs $(RPMDEFS) $(SPEC)

rpm : $(TARBALL) Makefile
	rpmbuild -ba $(RPMDEFS) $(SPEC)

clean :
	rm -f $(TARBALL) *.src.rpm

always:

.PHONY : srpm clean always

=== kernel/linux/efa/src/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0 OR BSD-2-Clause
# Copyright 2021-2025 Amazon.com, Inc. or its affiliates. All rights reserved.

list(APPEND efa_sources
  efa_com_cmd.c efa_com.c efa_main.c efa_verbs.c efa_sysfs.c
  efa_admin_cmds_defs.h efa_admin_defs.h efa_com_cmd.h efa_com.h
  efa_common_defs.h efa_regs_defs.h efa_sysfs.h
  efa_io_defs.h efa-abi.h efa.h kcompat.h)
if(ENABLE_P2P)
  list(APPEND efa_sources efa_p2p.c efa_p2p.h efa_nvmem_impl.h efa_nvmem_v1.c
    efa_nvmem_v2.c nv-p2p.h nv-p2p_v2.h efa_neuronmem.c neuron_p2p.h)
endif()
if(ENABLE_KVERBS)
  list(APPEND efa_sources efa_verbs.h efa_data_verbs.c)
endif()

string(REPLACE ";" " " efa_sources_string "${efa_sources}")
configure_file(Kbuild.in Kbuild @ONLY)

foreach(src ${efa_sources})
  configure_file(${src} ${src} COPYONLY)
endforeach()

# Generate config.h
include(${CMAKE_SOURCE_DIR}/config/efa.cmake)
if(ENABLE_P2P)
  config_define(HAVE_EFA_P2P)
  message("-- Peer-to-peer memory enabled")
endif()
if(ENABLE_KVERBS)
  config_define(HAVE_EFA_KVERBS)
  message("-- Kernel verbs support enabled")
endif()

set(module_cmd make -C ${KERNEL_DIR} M=${CMAKE_CURRENT_BINARY_DIR})
if(GCOV_PROFILE)
  set(module_cmd ${module_cmd} GCOV_PROFILE=y)
endif()
add_custom_command(OUTPUT efa.ko
  COMMAND ${module_cmd} modules
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${efa_sources} ${CMAKE_CURRENT_BINARY_DIR}/Kbuild ${CMAKE_CURRENT_BINARY_DIR}/config.h
  VERBATIM)

add_custom_target(modules ALL DEPENDS efa.ko)
add_custom_target(modules_clean COMMAND ${module_cmd} clean)

=== kernel/linux/efa_nv_peermem/rpm/Makefile ===
# Makefile for creating rpm of the Amazon EFA NV Peermem driver

NAME = efa-nv-peermem
SPEC = $(NAME).spec
VERSION	= 1.2.2

TOPDIR  := $(shell git rev-parse --show-toplevel)
TAG	?= HEAD
TARBALL	= $(NAME)-$(VERSION).tar

RPMDEFS = --define '_topdir  %(pwd)' \
          --define '_ntopdir %(pwd)' \
          --define '_builddir  %{_ntopdir}/build' \
          --define '_buildrootdir %{_builddir}' \
          --define '_sourcedir %{_ntopdir}' \
          --define '_specdir   %{_ntopdir}' \
          --define '_rpmdir    %{_ntopdir}' \
          --define '_srcrpmdir %{_ntopdir}' \
	  --define "driver_version $(VERSION)"

all : rpm

tarball : $(TARBALL)
$(TARBALL) : always
	(cd $(TOPDIR) && \
	git archive --format=tar --prefix=$(NAME)-$(VERSION)/ $(TAG) \
	kernel/linux/efa_nv_peermem/) > $@

srpm : $(TARBALL) Makefile
	rpmbuild -bs $(RPMDEFS) $(SPEC)

rpm : $(TARBALL) Makefile
	rpmbuild -ba $(RPMDEFS) $(SPEC)

clean :
	rm -f $(TARBALL) *.src.rpm

always:

.PHONY : srpm clean always

=== kernel/linux/efa_nv_peermem/src/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0 OR BSD-2-Clause
# Copyright 2023-2024 Amazon.com, Inc. or its affiliates. All rights reserved.

list(APPEND efa_nv_peermem_sources
  nv-p2p.h efa_nv_peermem.h efa_nv_peermem_main.c)

string(REPLACE ";" " " efa_nv_peermem_sources_string "${efa_nv_peermem_sources}")
configure_file(Kbuild.in Kbuild @ONLY)

if(NVIDIA_DIR)
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/Kbuild
"KBUILD_EXTRA_SYMBOLS = ${NVIDIA_MODULE_SYMVERS}")
endif()

foreach(src ${efa_nv_peermem_sources})
  configure_file(${src} ${src} COPYONLY)
endforeach()

set(module_cmd make -C ${KERNEL_DIR} M=${CMAKE_CURRENT_BINARY_DIR})
if(GCOV_PROFILE)
  set(module_cmd ${module_cmd} GCOV_PROFILE=y)
endif()
add_custom_command(OUTPUT efa_nv_peermem.ko
 COMMAND ${module_cmd} modules
 WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
 DEPENDS ${efa_nv_peermem_sources} ${CMAKE_CURRENT_BINARY_DIR}/Kbuild
 VERBATIM)

add_custom_target(modules ALL DEPENDS efa_nv_peermem.ko)
add_custom_target(modules_clean COMMAND ${module_cmd} clean)

=== kernel/linux/efa/debian/changelog ===
efa (2.17.3-1.amzn1) unstable; urgency=medium
  * Support P2P with NVIDIA 580 drivers
  * Adjust MR registration for 6.17 and on kernels
  * Fix kernel QP creation when depth is not a power of 2

 -- Michael Margolin <mrgolin@amazon.com>  Wed, 24 Sep 2025 06:10:54 +0000

efa (2.17.2-1.amzn1) unstable; urgency=medium
  * Fix create user CQ

 -- Yonatan Nachum <ynachum@amazon.com>  Mon, 21 Jul 2025 10:46:12 +0000

efa (2.17.1-1.amzn1) unstable; urgency=medium
  * Fix create kernel CQ backport

 -- Yonatan Nachum <ynachum@amazon.com>  Wed, 16 Jul 2025 13:39:55 +0000

efa (2.17.0-1.amzn1) unstable; urgency=medium
  * Add Network HW statistics counters
  * Add CQ with external memory support

 -- Yonatan Nachum <ynachum@amazon.com>  Tue, 15 Jul 2025 10:15:23 +0000

efa (2.15.3-1.amzn1) unstable; urgency=medium
  * Fix cmake dependency on Amazon Linux 2

 -- Michael Margolin <mrgolin@amazon.com>  Wed, 04 Jun 2025 13:05:57 +0000

efa (2.15.2-1.amzn1) unstable; urgency=medium
  * Fix cmake 4.0 compatibility failure

 -- Yonatan Nachum <ynachum@amazon.com>  Tue, 03 Jun 2025 09:35:06 +0000

efa (2.15.1-1.amzn1) unstable; urgency=medium
  * Cleanup destroy CQ kernel compatibility
  * Remove backports for kernels older than 4.14
  * Fix support for RHEL 9.6 compatibility

 -- Yonatan Nachum <ynachum@amazon.com>  Mon, 26 May 2025 07:16:41 +0000

efa (2.15.0-1.amzn1) unstable; urgency=medium
  * Fix page size optimization for large physically contiguous MRs
  * Cleanup interrupt related code
  * Reset the device if driver initialization failed

 -- Michael Margolin <mrgolin@amazon.com>  Mon, 03 Mar 2025 15:22:27 +0000

efa (2.13.1-1.amzn1) unstable; urgency=medium
  * Adjust dmabuf MR registration interface for mainline 6.12 kernels

 -- Michael Margolin <mrgolin@amazon.com>  Sun, 12 Jan 2025 11:56:55 +0000

efa (2.13.0-1.amzn1) unstable; urgency=medium
  * Add an option to create QP with specific service level
  * Report link speed according to device parameters

 -- Michael Margolin <mrgolin@amazon.com>  Wed, 30 Oct 2024 14:40:53 +0000

efa (2.12.1-1.amzn1) unstable; urgency=medium
  * Fix RNR configuration for SRD kernel QPs

 -- Michael Margolin <mrgolin@amazon.com>  Sun, 06 Oct 2024 16:13:23 +0000

efa (2.12.0-1.amzn1) unstable; urgency=medium
  * Introduce EFA kernel verbs support
  * Add 0xefa3 device support
  * Report device node GUID
  * Adjust CQ creation interface for mainline 6.11 kernels

 -- Michael Margolin <mrgolin@amazon.com>  Tue, 01 Oct 2024 09:17:30 +0000

efa (2.10.0-1.amzn1) unstable; urgency=medium
  * Introduce QP with unsolicited write with immediate receive
  * Add gracefull shutdown
  * Limit EQs to available MSI-X vectors
  * Improve admin completions error handling
  * Improve error handling on missing BARs

 -- Michael Margolin <mrgolin@amazon.com>  Wed, 05 Jun 2024 14:15:47 +0000

efa (2.8.0-1.amzn1) unstable; urgency=medium
  * Introduce Query MR support
  * Expose underlying interconnects used to reach memory regions
  * Fix compilation issues for mainline 6.8 kernels

 -- Michael Margolin <mrgolin@amazon.com>  Thu, 15 Feb 2024 10:30:27 +0000

efa (2.6.0-1.amzn1) unstable; urgency=medium
  * Fix wrong resources destruction order
  * Enable Nvidia GDR using P2P on up-to-date kernels
  * Expose accelerator memory P2P provider in sysfs

 -- Michael Margolin <mrgolin@amazon.com>  Thu, 09 Nov 2023 14:41:36 +0000

efa (2.5.0-1.amzn1) unstable; urgency=medium
  * Add RDMA write statistics

 -- Michael Margolin <mrgolin@amazon.com>  Tue, 11 Jul 2023 12:36:58 +0000

efa (2.4.1-1.amzn1) unstable; urgency=medium
  * Fix memory registration for systems with PAGE_SIZE > 4K

 -- Michael Margolin <mrgolin@amazon.com>  Thu, 01 Jun 2023 09:35:00 +0000

efa (2.4.0-1.amzn1) unstable; urgency=medium
  * Add data polling support
  * Add RDMA write support

 -- Michael Margolin <mrgolin@amazon.com>  Thu, 04 May 2023 11:28:27 +0000

efa (2.1.1-1.amzn1) unstable; urgency=medium
  * Fix dmabuf backport for some kernels

 -- Michael Margolin <mrgolin@amazon.com>  Tue, 08 Nov 2022 20:46:40 +0000

efa (2.1.0-1.amzn1) unstable; urgency=medium
  * Add support for CQ receive entries with source GID
  * Add 0xefa2 device support
  * Fix sysfs show on older kernels

 -- Michael Margolin <mrgolin@amazon.com>  Thu, 27 Oct 2022 19:47:18 +0000

efa (1.16.0-1.amzn1) unstable; urgency=medium
  * Add CQ notifications
  * Add support for dmabuf
  * Add NeuronLink RDMA support
  * Remove gdr from module info keys

 -- Firas Jahjah <firasj@amazon.com>  Mon, 24 Jan 2022 16:03:29 +0000

efa (1.14.2-1.amzn1) unstable; urgency=medium
  * Various GDR fixes

 -- Firas Jahjah <firasj@amazon.com>  Sun, 17 Oct 2021 22:16:33 +0000

efa (1.14.1-1.amzn1) unstable; urgency=medium
  * Make gdr sysfs return zero in case nvidia symbols are not available

 -- Firas Jahjah <firasj@amazon.com>  Thu, 23 Sep 2021 15:27:31 +0000

efa (1.14.0-1.amzn1) unstable; urgency=medium
  * Unify the standard and GDR packages
  * Split hardware stats to device and port stats
  * Fix unfree'd IRQ vectors on error flow
  * Fix potential deadlock in GDR flow

 -- Gal Pressman <galpress@amazon.com>  Tue, 14 Sep 2021 09:49:22 +0000

efa (1.13.0-1.amzn1) unstable; urgency=medium
  * Remove static dependency of nvidia module in GDR driver
  * Fix potential memory leak in GDR memory registration error flow
  * Upstream kernel alignments
  * Remove old kernel APIs

 -- Gal Pressman <galpress@amazon.com>  Tue, 06 Jul 2021 14:31:39 +0000

efa (1.12.3-1.amzn1) unstable; urgency=medium
  * Fix potential NULL pointer dereference when using GDR on newer kernel version

 -- Gal Pressman <galpress@amazon.com>  Sun, 27 Jun 2021 11:03:33 +0000

efa (1.12.2-1.amzn1) unstable; urgency=medium
  * Fix mmap flow for applications compiled with EXEC permissions
  * Couple of packaging fixes

 -- Gal Pressman <galpress@amazon.com>  Wed, 16 Jun 2021 14:10:22 +0000

efa (1.12.1-1.amzn1) unstable; urgency=medium


=== kernel/linux/efa_nv_peermem/debian/changelog ===
efa-nv-peermem (1.2.2-1.amzn1) unstable; urgency=medium
  * Fix Nvidia Module.symvers search

 -- Yonatan Nachum <ynachum@amazon.com>  Mon, 21 Jul 2025 04:51:00 +0000

efa-nv-peermem (1.2.1-1.amzn1) unstable; urgency=medium
  * Fix cmake dependency on Amazon Linux 2
  * Fix Nvidia DKMS dependency

 -- Michael Margolin <mrgolin@amazon.com>  Wed, 04 Jun 2025 13:04:31 +0000

efa-nv-peermem (1.2.0-1.amzn1) unstable; urgency=medium
  * Fix cmake 4.0 compatibility failure
  * Add interface definitions header

 -- Yonatan Nachum <ynachum@amazon.com>  Tue, 03 Jun 2025 11:24:52 +0000

efa-nv-peermem (1.1.1-1.amzn1) unstable; urgency=medium
  * Reduce build process output to stdout

 -- Michael Margolin <mrgolin@amazon.com>  Thu, 15 Feb 2024 08:08:00 +0000

efa-nv-peermem (1.1.0-1.amzn1) unstable; urgency=medium
  * Initial release of efa_nv_peermem kernel driver Debian package

 -- Michael Margolin <mrgolin@amazon.com>  Wed, 25 Oct 2023 16:42:57 +0000

=== kernel/linux/efa_nv_peermem/debian/control ===
Source: efa-nv-peermem
Maintainer: ec2-efa-maintainers <ec2-efa-maintainers@amazon.com>
Build-Depends: debhelper
Standards-Version: 4.3.0
Homepage: https://github.com/amzn/amzn-drivers

Package: efa-nv-peermem
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, dkms, cmake
Description: Linux kernel driver for EFA Nvidia peermem
 Elastic Fabric Adapter (EFA) peermem provides an interface for nv-p2p
 capabilities for the EFA driver use.

=== kernel/linux/efa/debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

NAME	= efa
VERSION = 2.17.3
DESTDIR:=`pwd`/debian/${NAME}
INSTALL_PATH = /usr/src/${NAME}-${VERSION}


%:
	dh $@

override_dh_auto_clean:
	dh_clean

override_dh_auto_build:
	echo "Skip build"

override_dh_auto_configure:
	echo "Skip configure"

override_dh_auto_install:
	mkdir -p ${DESTDIR}/${INSTALL_PATH}
	mkdir -p ${DESTDIR}/${INSTALL_PATH}/config
	mkdir -p ${DESTDIR}/${INSTALL_PATH}/src
	install -D -m 644 conf/efa.conf		${DESTDIR}/etc/modules-load.d/efa.conf
	install -D -m 644 conf/efa-modprobe.conf ${DESTDIR}/etc/modprobe.d/efa.conf
	install -m 644 conf/dkms.conf		${DESTDIR}/${INSTALL_PATH}
	install -m 744 conf/configure-dkms.sh	${DESTDIR}/${INSTALL_PATH}
	install -m 644 src/efa_com.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_com_cmd.c	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_main.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_sysfs.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_verbs.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_data_verbs.c	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa-abi.h 		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_admin_cmds_defs.h ${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_admin_defs.h 	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_com_cmd.h	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_com.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_common_defs.h	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_io_defs.h	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_verbs.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_regs_defs.h	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_sysfs.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/kcompat.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/CMakeLists.txt	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/Kbuild.in		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_p2p.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_p2p.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_nvmem_impl.h	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_nvmem_v1.c	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_nvmem_v2.c	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/nv-p2p.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/nv-p2p_v2.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_neuronmem.c	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/neuron_p2p.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 README			${DESTDIR}/${INSTALL_PATH}
	install -m 644 RELEASENOTES.md		${DESTDIR}/${INSTALL_PATH}
	install -m 644 CMakeLists.txt		${DESTDIR}/${INSTALL_PATH}
	install -m 644 config/Makefile		${DESTDIR}/${INSTALL_PATH}/config
	install -m 644 config/main.c.in		${DESTDIR}/${INSTALL_PATH}/config
	install -m 744 config/compile_conftest.sh	${DESTDIR}/${INSTALL_PATH}/config
	install -m 744 config/wait_for_pid.sh	${DESTDIR}/${INSTALL_PATH}/config
	install -m 644 config/efa.cmake		${DESTDIR}/${INSTALL_PATH}/config
	install -m 744 config/runbg.sh		${DESTDIR}/${INSTALL_PATH}/config

=== kernel/linux/efa_nv_peermem/debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

NAME	= efa-nv-peermem
VERSION = 1.2.2
DESTDIR:=`pwd`/debian/${NAME}
INSTALL_PATH = /usr/src/${NAME}-${VERSION}


%:
	dh $@

override_dh_auto_clean:
	dh_clean

override_dh_auto_build:
	echo "Skip build"

override_dh_auto_configure:
	echo "Skip configure"

override_dh_auto_install:
	mkdir -p ${DESTDIR}/${INSTALL_PATH}
	mkdir -p ${DESTDIR}/${INSTALL_PATH}/config
	mkdir -p ${DESTDIR}/${INSTALL_PATH}/src
	install -D -m 644 conf/efa_nv_peermem.conf		${DESTDIR}/etc/modules-load.d/efa_nv_peermem.conf
	install -m 644 conf/dkms.conf				${DESTDIR}/${INSTALL_PATH}
	install -m 744 conf/configure-dkms.sh			${DESTDIR}/${INSTALL_PATH}
	install -m 644 src/efa_nv_peermem_main.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_nv_peermem.h			${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/nv-p2p.h				${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/CMakeLists.txt			${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/Kbuild.in				${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 README					${DESTDIR}/${INSTALL_PATH}
	install -m 644 RELEASENOTES.md				${DESTDIR}/${INSTALL_PATH}
	install -m 644 CMakeLists.txt				${DESTDIR}/${INSTALL_PATH}
